\begin{tikzpicture}[framed]
  \tikzstyle{arrow} = [ultra thick,->,>=stealth]

  \node [
    rectangle, draw, fill=yellow!50, text width=6em, text centered, ultra thick,
    rounded corners, minimum height=4em
  ] (supervisor) {supervisor};

  \node [
    rectangle, draw, fill=red!50, text width=6em, text centered, ultra thick,
    rounded corners, minimum height=4em, right=6em of supervisor
  ] (controller) {robot navigator};

  \node [
    rectangle, draw, fill=cyan!50, text width=6em, text centered, ultra thick,
    rounded corners, minimum height=4em, right=6em of controller
  ] (robot) {mobile robot};

  \node [
    rectangle, draw, fill=yellow,
    minimum height=20em, minimum width=0.1em, below=of supervisor
  ] (supervisor_timeline) {};

  \node [
    rectangle, draw, fill=red,
    minimum height=20em, minimum width=0.1em, below=of controller
  ] (controller_timeline) {};

  \node [
    rectangle, draw, fill=cyan,
    minimum height=20em, minimum width=0.1em, below=of robot
  ] (robot_timeline) {};

  \draw [dashed, thin] (supervisor) -- (supervisor_timeline);
  \draw [dashed, thin] (controller) -- (controller_timeline);
  \draw [dashed, thin] (robot) -- (robot_timeline);

  \draw [arrow]
    ([yshift=-0.5em]controller_timeline.north west) --
    ([yshift=-0.5em]supervisor_timeline.north east)
    node [midway, above] {request $s_k$};

  \draw [arrow]
  ([yshift=-1em]supervisor_timeline.north east) --
  ([yshift=-1em]controller_timeline.north west)
    node [midway, below] {confirm $s_k$};

  \draw [arrow, dashed]
    ([yshift=-1em]controller_timeline.north east) --
    ([yshift=-1em]robot_timeline.north west)
    node [midway, above] {move forward};

  \draw [arrow, dashed]
    ([yshift=-4em]controller_timeline.north west) --
    ([yshift=-4em]supervisor_timeline.north east)
    node [midway, above] {fully entered $s_k$};

  \draw [arrow, dashed]
    ([yshift=-6em]controller_timeline.north west) --
    ([yshift=-6em]supervisor_timeline.north east)
    node [midway, above] {released $s_{k-1}$};

  \draw [arrow]
    ([yshift=-10em]controller_timeline.north west) --
    ([yshift=-10em]supervisor_timeline.north east)
    node [midway, above] {request $s_{k+1}$};

  \draw [arrow]
  ([yshift=-10.5em]supervisor_timeline.north east) --
  ([yshift=-10.5em]controller_timeline.north west)
    node [midway, below] {confirm $s_{k+1}$};

  \draw [arrow, dashed]
    ([yshift=-13.5em]controller_timeline.north west) --
    ([yshift=-13.5em]supervisor_timeline.north east)
    node [midway, above] {fully entered $s_{k+1}$};

  \draw [arrow, dashed]
    ([yshift=-15.5em]controller_timeline.north west) --
    ([yshift=-15.5em]supervisor_timeline.north east)
    node [midway, above] {released $s_{k}$};

  \begin{scope}[on behind layer]
    \node [rectangle, draw, fill=red!20, minimum height=6em, anchor=north]
      (segment_kp) at (controller_timeline.north east) {}
      node [rotate=90] at ([xshift=0.5em]segment_kp.east) {$s_{k-1}$};

    \node [rectangle, draw, fill=red!20, minimum height=14.5em, anchor=north]
      (segment_k) at ([yshift=-1em]controller_timeline.north west) {}
      node [rotate=90] at ([xshift=-0.5em]segment_k.west) {$s_k$};

    \node [rectangle, draw, fill=red!20, minimum height=9.5em, anchor=north]
      (segment_kn) at ([yshift=-10.5em]controller_timeline.north east) {}
      node [rotate=90] at ([xshift=0.5em]segment_kn.east) {$s_{k+1}$};

    \node [rectangle, draw, fill=cyan!20, minimum height=19em, anchor=north]
      (moving_forward) at ([yshift=-1em]robot_timeline.north west) {}
      node [rotate=90] at ([xshift=-0.5em]moving_forward.west) {moving};
  \end{scope}
\end{tikzpicture}
